//
// Our defines
//

//	Port Definitions
//	Port 0


//	Port 1

#define		STOP_ON		0b00010000
#define		NMC_R_ON	0b00001000
#define		NMC_B_ON	0b00000100
#define		SMC_R_ON	0b00000010
#define		SMC_B_ON	0b00000001

#define		STOP_OFF	0b11101111
#define		NMC_R_OFF	0b11110111
#define		NMC_B_OFF	0b11111011
#define		SMC_R_OFF	0b11111101
#define		SMC_B_OFF	0b11111110

#define		NMC_OFF		0b11110011
#define		SMC_OFF		0b11111100
#define		BOTH_OFF	0b11110000
#define		EMC_ON		0b00001100
#define		WMC_ON		0b00000011
#define		BOTH_ON		0b00001111

// Port 2

#define		NS_LS1_ON	0b01111111
#define		NS_LS12_ON	0b00111111
#define		NS_LS2_ON	0b10111111
#define		NS_LS23_ON	0b10011111
#define		NS_LS3_ON	0b11011111
#define		NS_LS34_ON	0b11001111
#define		NS_LS4_ON	0b11101111
#define		NS_LS45_ON	0b11100111
#define		NS_LS5_ON	0b11110111
#define		NS_LS56_ON	0b11110011
#define		NS_LS6_ON	0b11111011
#define		NS_LS67_ON	0b11111001
#define		NS_LS7_ON	0b11111101
#define		IS_LN_MSK	0b00000001
#define		ALL_OFF		0b11111111
#define     NS_LS123_ON	0b00011111
#define		NS_LS234_ON	0b10001111
#define		NS_LS345_ON	0b11000111
#define		NS_LS456_ON	0b11100011
#define		NS_LS567_ON	0b11110001
#define		LS_MSK1		0b00011111
#define		LS_MSK2		0b10001111
#define		LS_MSK3		0b11000111
#define		LS_MSK4		0b11100011
#define		LS_MSK5		0b11110001
#define		LS_MSK6		0b00001111
#define		LS_MSK7		0b10000111
#define		LS_MSK8		0b11000011
#define		LS_MSK9		0b11100001
#define		LS_MSK10	0b01011111
#define		LS_MSK11	0b10101111
#define		LS_MSK12	0b11010111
#define		LS_MSK13	0b11101011
#define		LS_MSK14	0b11110101
#define		LS_MSK15	0b01101111
#define		LS_MSK16	0b10110111
#define		LS_MSK17	0b11011011
#define		LS_MSK18	0b11101101

#define		LF_ON		0b01000000
#define		IS_DT		0b10000000
#define		ALIGN		0b00000010

#define		SOUTH	0
#define		NORTH	1
#define		BOTH	2

#define		ON		1
#define		OFF		0

#define		EW_PSOC		0b00000001
#define		NS_PSOC		0b11111110
#define		PSOCSTART	0b11110111
#define		PSOCSTOP	0b00001000
#define		STSWORD		0b10000000
#define		LINERIGHT	0b11101111
#define		LINELEFT	0b00010000
#define		LTWEIGHT	0b00000010
#define		MDWEIGHT	0b00000100
#define		HVWEIGHT	0b00000110
#define		NOWEIGHT	0b11111001
#define		OFFLINE		0b01000000
#define		CENTER		0b00100000

// Velocity codes		

// Velocity codes

#define		SLOWP6		220		// S6 Plus 100
#define		SLOWP5		210		// S5 Plus 90
#define		SLOWP4		200		// S4 Plus 80
#define		SLOWP3		165		// S3 Plus 40
#define		SLOWP2		155		// S2 Plus 20
#define		SLOWP1		145		// S1 Plus 10
#define		SLOW		140
#define		SLOWS1		135
#define		SLOWS2		130
#define		SLOWS3		125
#define		SLOWS4		120
#define		SLOWS5		120
#define		SLOWS6		120
#define		MEDIUMP6	400		// S6 Plus 100
#define		MEDIUMP5	350		// S5 Plus 80
#define		MEDIUMP4	300		// S4 Plus 60
#define		MEDIUMP3	275		// S3 Plus 40
#define		MEDIUMP2	250		// S2 Plus 20
#define		MEDIUMP1	225		// S1 Plus 10
#define		MEDIUM		160
#define		MEDIUMS1	190
#define		MEDIUMS2	180
#define		MEDIUMS3	170
#define		MEDIUMS4	160
#define		MEDIUMS5	150
#define		MEDIUMS6	140
#define		FASTP6		430		// S6 Plus 100
#define		FASTP5		425		// S5 Plus 80
#define		FASTP4		420		// S4 Plus 60	
#define		FASTP3		415		// S3 Plus 40
#define		FASTP2		410		// S2 Plus 20
#define		FASTP1		405		// S1 Plus 10
#define		FAST		180	
#define		FASTS1		395
#define		FASTS2		390
#define		FASTS3		390
#define		FASTS4		390
#define		FASTS5		390
#define		FASTS6		390	

// Motion type

#define		TRANS	0
#define		ROT		1

// Command status codes

#define		OLD		0
#define		NEW		1

// Direction Codes

#define		FWD		0
#define		BWD		1

#define		RIGHT	0
#define		LEFT	1

// A XBC command structure

typedef struct
{
  	BOOL	 MotionType;   		// 0 = Translation
  	int	 	 Velocity;
  	BOOL	 Direction;  		// 0 = fwd, 1 = bwd
  	BOOL	 Status;			// Either OLD or NEW
  	BOOL	 LineFollow;	    
  	BOOL	 Offline;	    	// 0 = right, 1 = left
  	BOOL	 Center;
  	BOOL	 END_SENSOR;
   	int		 VP6;
  	int		 VP5;
  	int		 VP4;
  	int		 VP3;
  	int		 VP2;
  	int		 VP1;
  	int		 VS1;
  	int		 VS2;
  	int		 VS3;
  	int		 VS4;
  	int		 VS5;
  	int		 VS6;
} CmdStruct;

// A wheel structure

typedef	struct
{
	int id;					// Either RIGHT or LEFT
	int	direction;
	int Velocity;
} WheelStruct;

//////////////////////////////////////////////////////////////////////
//
// FUNCTION DECLARATIONS
//
/////////////////////////////////////////////////////////////////////////
BOOL 	ScanForKeyPress(void);
void 	initPSoC(void);					//	PSoC initialization routine
void 	Motor(int, int, BOOL);			//  Motor, PWMvalue, direction
void 	StopMotor(int);		    		//  Stops either motor 0 or motor 1 or BOTH!
void	ProcessRxByte(BYTE, CmdStruct *);
void 	ControlWheel(CmdStruct *, WheelStruct *);
