	cpu LMM
	.module utilities.c
	.area text(rom, con, rel)
	.dbfile ./utilities.c
	.dbfunc e initPSoC _initPSoC fV
_initPSoC::
	.dbline -1
	.dbline 11
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include <stdlib.h>
; #include "motorcontroller.h"
; 
; ///////////////////////////////////////////////////////////////////////////////
; 
; // PSoC initialization routine
; 
; void initPSoC(void)
; {
	.dbline 16
; 
; // Initialize the UART receiver
; // No parity
; 
; 	RX8_1_Start(RX8_PARITY_NONE);
	push X
	mov A,0
	xcall _RX8_1_Start
	.dbline 17
; 	TX8_2_Start(TX8_PARITY_NONE);
	mov A,0
	xcall _TX8_2_Start
	.dbline 21
; 
; // Enable PWM8_1 for motor 0 (left-side motor)
; 
; 	PWM8_1_DisableInt();
	xcall _PWM8_1_DisableInt
	.dbline 22
; 	PWM8_1_WritePulseWidth(0);
	mov A,0
	xcall _PWM8_1_WritePulseWidth
	.dbline 23
; 	PWM8_1_Start();
	xcall _PWM8_1_Start
	.dbline 27
; 
; // Enable PWM8_2 for motor 1 (right-side motor)
; 
; 	PWM8_2_DisableInt();
	xcall _PWM8_2_DisableInt
	.dbline 28
; 	PWM8_2_WritePulseWidth(0);
	mov A,0
	xcall _PWM8_2_WritePulseWidth
	.dbline 29
; 	PWM8_2_Start();
	xcall _PWM8_2_Start
	.dbline 33
; 	
; //	Stop the 16 bit encoder counters
; 
;     Counter16_1_Stop();
	xcall _Counter16_1_Stop
	.dbline 34
;     Counter16_2_Stop();	
	xcall _Counter16_2_Stop
	.dbline 38
; 	
; // Turn on the 14 bit ADC
; 
;    ADCINC14_1_Start(ADCINC14_1_HIGHPOWER);   // Turn on ADC
	mov A,3
	xcall _ADCINC14_1_Start
	.dbline 42
; 
; // Start up the instrumentation amplifier
; 
;    INSAMP_1_Start(INSAMP_1_HIGHPOWER);
	mov A,3
	xcall _INSAMP_1_Start
	.dbline 43
;    INSAMP_1_Set2StageGain(INSAMP_1_INGAIN_48, INSAMP_1_OUTGAIN_1_94);	
	mov X,31
	mov A,1
	xcall _INSAMP_1_Set2StageGain
	.dbline 46
; 
; // Enable timer interrupts needed for scheduling
; 	Timer16_1_EnableInt();
	xcall _Timer16_1_EnableInt
	.dbline 47
; 	Timer16_1_Start();
	xcall _Timer16_1_Start
	.dbline 48
; 	Timer8_1_Start();
	xcall _Timer8_1_Start
	pop X
	.dbline 51
; 
; // Enable all interrupts
; 	M8C_EnableGInt;
		or  F, 01h

	.dbline 53
; 	
; 	return;
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e PIDinit _PIDinit fV
;            pid -> X-5
_PIDinit::
	.dbline -1
	push X
	mov X,SP
	.dbline 63
; }
; 
; /////////////////////////////////////////////////////////////////////////////
; 
; /*
;  Routine to initialize PID control loop parameters
; */
; 
; void PIDinit(PIDstruct * pid)
; {
	.dbline 64
; 	pid->pGain = 1.0; 		// originally 1.0
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,20
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,63
	mvi [__r1],A
	mov A,-128
	mvi [__r1],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 66
; 
;     pid->dGain = .1;	// originally 100.0
	mov A,[X-4]
	add A,24
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,61
	mvi [__r1],A
	mov A,-52
	mvi [__r1],A
	mvi [__r1],A
	mov A,-51
	mvi [__r1],A
	.dbline 68
; 
; 	pid->iGain = .5;		// originally .01
	mov A,[X-4]
	add A,16
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,63
	mvi [__r1],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	.dbline 70
; 
; 	pid->iState = PWM_MIN;
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	.dbline 71
; 	pid->dState = 0.0;
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	.dbline 72
; 	pid->iMin = PWM_MIN;
	mov A,[X-4]
	add A,12
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	mvi [__r1],A
	.dbline 73
; 	pid->iMax = PWM_MAX;
	mov A,[X-4]
	add A,8
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,67
	mvi [__r1],A
	mov A,127
	mvi [__r1],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 75
; 
; 	return;
	.dbline -2
L5:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l pid -5 pX
	.dbend
	.dbfunc e Motor _Motor fV
; MotorDirection -> X-8
;       PWMvalue -> X-7
;      MotorCode -> X-5
_Motor::
	.dbline -1
	push X
	mov X,SP
	.dbline 80
; }
; ////////////////////////////////////////////////////////////////////////
; 
; void Motor(int MotorCode, int PWMvalue, BOOL MotorDirection)
; {										// PWMvalue 0-255
	.dbline 81
;    if (MotorCode == NORTH) 				// North motor
	cmp [X-5],0
	jnz L7
	cmp [X-4],1
	jnz L7
X0:
	.dbline 82
;    {
	.dbline 83
; 	   if(MotorDirection == FWD)		// Forward
	cmp [X-8],0
	jnz L9
	.dbline 84
; 	   {
	.dbline 85
; 		   PRT1DR |= NMC_R_ON;
	or REG[0x4],8
	.dbline 86
; 		   PRT1DR &= NMC_B_OFF;
	and REG[0x4],-5
	.dbline 87
; 	   }
	xjmp L10
L9:
	.dbline 90
; 
; 	   else 							// Backward
; 	   {
	.dbline 91
; 		   PRT1DR &= NMC_R_OFF;
	and REG[0x4],-9
	.dbline 92
; 		   PRT1DR |= NMC_B_ON;
	or REG[0x4],4
	.dbline 93
; 	   }
L10:
	.dbline 95
; 
; 	   PWM8_2_WritePulseWidth(PWMvalue);
	mov REG[0xd0],>__r0
	mov A,[X-6]
	push X
	xcall _PWM8_2_WritePulseWidth
	pop X
	.dbline 96
;    }
	xjmp L6
L7:
	.dbline 99
; 
;    else 								// South motor
;    {
	.dbline 100
; 	   if(MotorDirection == FWD)		// Forward
	cmp [X-8],0
	jnz L11
	.dbline 101
; 	   {
	.dbline 102
; 		   PRT1DR |= SMC_R_ON;
	or REG[0x4],2
	.dbline 103
; 		   PRT1DR &= SMC_B_OFF;
	and REG[0x4],-2
	.dbline 104
; 	   }
	xjmp L12
L11:
	.dbline 107
; 
; 	   else 							// Backward
; 	   {
	.dbline 108
; 		   PRT1DR &= SMC_R_OFF;
	and REG[0x4],-3
	.dbline 109
; 		   PRT1DR |= SMC_B_ON;
	or REG[0x4],1
	.dbline 110
; 	   }
L12:
	.dbline 112
; 
; 	   PWM8_1_WritePulseWidth(PWMvalue);
	mov REG[0xd0],>__r0
	mov A,[X-6]
	push X
	xcall _PWM8_1_WritePulseWidth
	pop X
	.dbline 113
;    }
	.dbline 115
; 
;    return;
	.dbline -2
L6:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l MotorDirection -8 c
	.dbsym l PWMvalue -7 I
	.dbsym l MotorCode -5 I
	.dbend
	.dbfunc e StopMotor _StopMotor fV
;      MotorCode -> X-5
_StopMotor::
	.dbline -1
	push X
	mov X,SP
	.dbline 122
; }
; 
; //////////////////////////////////////////////////////////////////////
; 
; // Stop Function
; void StopMotor(int MotorCode)
; {
	.dbline 123
; 	if (MotorCode == SOUTH)				// Stop South Motor
	cmp [X-5],0
	jnz L14
	cmp [X-4],0
	jnz L14
X1:
	.dbline 124
; 	{
	.dbline 125
; 		PRT1DR &= SMC_OFF;
	and REG[0x4],-4
	.dbline 126
; 	}
L14:
	.dbline 128
; 
; 	if (MotorCode == NORTH)				// Stop North Motor
	cmp [X-5],0
	jnz L16
	cmp [X-4],1
	jnz L16
X2:
	.dbline 129
; 	{
	.dbline 130
; 		PRT1DR &= NMC_OFF;
	and REG[0x4],-13
	.dbline 131
; 	}
L16:
	.dbline 133
; 
; 	if (MotorCode == BOTH)				// Stop both motors
	cmp [X-5],0
	jnz L18
	cmp [X-4],2
	jnz L18
X3:
	.dbline 134
; 	{
	.dbline 135
; 		PRT1DR &= BOTH_OFF;
	and REG[0x4],-16
	.dbline 136
; 	}
L18:
	.dbline 138
; 
; 	PWM8_1_WritePulseWidth(0);
	push X
	mov A,0
	xcall _PWM8_1_WritePulseWidth
	.dbline 139
; 	PWM8_2_WritePulseWidth(0);
	mov A,0
	xcall _PWM8_2_WritePulseWidth
	pop X
	.dbline 141
; 
; 	return;
	.dbline -2
L13:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l MotorCode -5 I
	.dbend
	.area data(ram, con, rel)
	.dbfile ./utilities.c
L21:
	.word 0
	.area data(ram, con, rel)
	.dbfile ./utilities.c
L22:
	.word 0
	.area text(rom, con, rel)
	.dbfile ./utilities.c
	.dbfunc e ScanForKeyPress _ScanForKeyPress fc
	.dbsym s CurKeyState L22 I
	.dbsym s PrevKeyState L21 I
_ScanForKeyPress::
	.dbline -1
	.dbline 145
; }
; 
; BOOL ScanForKeyPress(void)
; {
	.dbline 149
; 	static	 	PrevKeyState = 0;
; 	static	 	CurKeyState = 0;
; 
;    	PrevKeyState = CurKeyState;
	mov REG[0xd0],>L22
	mov A,[L22+1]
	push A
	mov A,[L22]
	mov REG[0xd0],>L21
	mov [L21],A
	pop A
	mov [L21+1],A
	.dbline 151
; 
;    	if (PRT1DR & 0x20)
	tst REG[0x4],32
	jz L23
	.dbline 152
;    	{
	.dbline 153
;    		CurKeyState = KEY_UP;
	mov REG[0xd0],>L22
	mov [L22+1],1
	mov [L22],0
	.dbline 154
;    		PRT1DR ^= 0x20;
	xor REG[0x4],32
	.dbline 155
;    	}
	xjmp L24
L23:
	.dbline 158
; 
;    	else
;    	{
	.dbline 159
; 		CurKeyState = KEY_DWN;
	mov REG[0xd0],>L22
	mov [L22+1],0
	mov [L22],0
	.dbline 160
; 	}
L24:
	.dbline 162
; 
;    	if (PrevKeyState-CurKeyState == 1) 	// if button is released return true
	mov REG[0xd0],>L21
	mov A,[L21+1]
	mov REG[0xd0],>L22
	sub A,[L22+1]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>L21
	mov A,[L21]
	mov REG[0xd0],>L22
	sbb A,[L22]
	mov REG[0xd0],>__r0
	cmp A,0
	jnz L25
	cmp [__r1],1
	jnz L25
X4:
	.dbline 163
;    	{
	.dbline 164
; 		return TRUE;
	mov REG[0xd0],>__r0
	mov A,1
	xjmp L20
L25:
	.dbline 168
; 	}
; 
;    	else 								// else return false
;    	{
	.dbline 169
; 		return FALSE;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L20:
	.dbline 0 ; func end
	ret
	.dbend
